subroutine rccomp(chmat, mesh)
!
    implicit   none
!
#include "jeveux.h"
#include "asterc/getfac.h"
#include "asterfort/assert.h"
#include "asterfort/comp_comp_read.h"
#include "asterfort/comp_comp_save.h"
#include "asterfort/comp_init.h"
#include "asterfort/jedetr.h"
#include "asterfort/jedema.h"
#include "asterfort/jemarq.h"
#include "asterfort/utmess.h"
! ----------------------------------------------------------------------
! ======================================================================
! COPYRIGHT (C) 1991 - 2015  EDF R&D                  WWW.CODE-ASTER.ORG
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
! IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
! THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
! (AT YOUR OPTION) ANY LATER VERSION.
!
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
! WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.
!
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
!    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
! ======================================================================
!
    character(len=8), intent(in) :: chmat
    character(len=8), intent(in) :: mesh
!
! --------------------------------------------------------------------------------------------------
!
! AFFE_MATERIAU
!
! Create COMPOR <CARTE> for AFFE_COMPOR
!
! --------------------------------------------------------------------------------------------------
!
! In  mesh        : name of mesh
! In  chmat       : name material field
!
! --------------------------------------------------------------------------------------------------
!
    integer :: nb_cmp, nocc
    character(len=16) :: keywordfact
    character(len=19) :: compor
    character(len=24) :: list_vale
!
! --------------------------------------------------------------------------------------------------
!
    call jemarq()
!
    keywordfact = 'AFFE_COMPOR'
    compor = chmat//'.COMPOR'
    list_vale   = '&&LIST_VALE'
    call getfac(keywordfact, nocc)
    if (nocc .ne. 0) then
!
! ----- Create COMPOR <CARTE>
!
        call comp_init(mesh, compor, 'G', nb_cmp)
!
! ----- Read informations from command file
!
        call comp_comp_read(list_vale)
!
! ----- Save informations in COMPOR <CARTE>
!
        call comp_comp_save(mesh, compor, nb_cmp, list_vale)
!
! ----- Clean it
!
        call jedetr(list_vale)
    endif
!
    call jedema()
end subroutine
